## iwrite-3.1.1.0.tar.gz

=== Makefile ===
# vim:noexpandtab:softtabstop=2:tabstop=2:shiftwidth=2:nowrap
# 
# Copyright (c) 2015-2016, iwrite authors
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 
# 1. Redistributions of source code must retain the above copyright notice,
# this list of conditions and the following disclaimer.
# 
# 2. Redistributions in binary form must reproduce the above copyright
# notice, this list of conditions and the following disclaimer in the
# documentation and/or other materials provided with the distribution.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
# TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

.SILENT:

UNAME:= $(shell uname)
BITS:= $(shell uname -m)

SUFFIX= so

ifeq ($(UNAME), MINGW64_NT-10.0)

SUFFIX= dll

endif

ifndef prefix
	ifeq ($(UNAME), OpenBSD)
		prefix=/usr/local
	else ifeq ($(UNAME), FreeBSD)
		prefix=/usr/local
	else ifeq ($(UNAME), NetBSD)
		prefix=/usr/pkg
	else ifeq ($(UNAME), MINGW64_NT-10.0)
		prefix=/mingw64
	else
		prefix=/usr
	endif
endif

ifndef BINDIR
	BINDIR=${prefix}/bin
endif

ifndef LIBDIR
	LIBDIR=${prefix}/lib

	ifeq ($(UNAME), Linux)
		ifeq ($(BITS), x86_64)
			LIBDIR=${prefix}/lib64
		endif
	endif
endif

ifndef DATADIR
	DATADIR=${prefix}/share/iwrite
endif

UIDIR=${DATADIR}/ui

ifndef DOCDIR
	DOCDIR=${prefix}/share/doc/iwrite
endif

.PHONY: all
all: docs iwrite drivers

.PHONY: docs
docs: doc/iwrite.pdf
	@echo finished documentation

doc/iwrite.pdf:
	@cd doc && ${MAKE}

.PHONY: iwrite
iwrite: src/iwrite
	@echo finished iwrite

src/iwrite: 
	@cd src && ${MAKE}

.PHONY: drivers
ifeq ($(UNAME), Linux)
drivers:\
	drivers/postgres/libiwsql_pq.${SUFFIX} \
	drivers/mariadb/libiwsql_mariadb.${SUFFIX} \
	drivers/sqlite3/libiwsql_sqlite3.${SUFFIX} \
	drivers/oracle/libiwsql_oracle.${SUFFIX}
else
drivers:\
	drivers/postgres/libiwsql_pq.${SUFFIX} \
	drivers/mariadb/libiwsql_mariadb.${SUFFIX} \
	drivers/sqlite3/libiwsql_sqlite3.${SUFFIX}
endif
	@echo finished database drivers

drivers/postgres/libiwsql_pq.${SUFFIX}: 
	@cd drivers && ${MAKE} postgres

drivers/mariadb/libiwsql_mariadb.${SUFFIX}:
	@cd drivers && ${MAKE} mariadb

drivers/sqlite3/libiwsql_sqlite3.${SUFFIX}:
	@cd drivers && ${MAKE} sqlite3

drivers/oracle/libiwsql_oracle.${SUFFIX}:
	@cd drivers && ${MAKE} oracle

.PHONY: clean
clean:
	@echo making clean
	cd drivers && ${MAKE} clean
	cd src/decNumber && ${MAKE} clean
	cd src/icu && ${MAKE} clean
	cd src/ruler && ${MAKE} clean
	cd src/geometry && ${MAKE} clean
	cd src/zint && ${MAKE} clean
	cd src && ${MAKE} clean

.PHONY: install
install:
	@echo installing iwrite
	test -d ${DESTDIR}${BINDIR} || mkdir -p ${DESTDIR}${BINDIR}
	test -d ${DESTDIR}${LIBDIR} || mkdir -p ${DESTDIR}${LIBDIR}
	test -d ${DESTDIR}${DOCDIR} || mkdir -p ${DESTDIR}${DOCDIR}
	test -d ${DESTDIR}${DATADIR} || mkdir -p ${DESTDIR}${DATADIR}
	test -d ${DESTDIR}${UIDIR} || mkdir -p ${DESTDIR}${UIDIR}
	install -s -m 0655 src/iwrite ${DESTDIR}${BINDIR}/iwrite
	install -s -m 0755 drivers/postgres/libiwsql_pq.${SUFFIX} ${DESTDIR}${LIBDIR}/libiwsql_pq.${SUFFIX} 
	install -s -m 0755 drivers/mariadb/libiwsql_mariadb.${SUFFIX} ${DESTDIR}${LIBDIR}/libiwsql_mariadb.${SUFFIX} 
	install -s -m 0755 drivers/sqlite3/libiwsql_sqlite3.${SUFFIX} ${DESTDIR}${LIBDIR}/libiwsql_sqlite3.${SUFFIX} 
ifeq ($(UNAME), Linux)
	install -s -m 0755 drivers/oracle/libiwsql_oracle.${SUFFIX} ${DESTDIR}${LIBDIR}/libiwsql_oracle.${SUFFIX} 
endif
	install -m 0444 README ${DESTDIR}${DOCDIR}/README
	install -m 0444 COPYING ${DESTDIR}${DOCDIR}/COPYING
	install -m 0444 doc/iwrite.pdf ${DESTDIR}${DOCDIR}/iwrite.pdf
	install -m 0644 src/break.glade ${DESTDIR}${UIDIR}/break.glade
	install -m 0644 src/circle.glade ${DESTDIR}${UIDIR}/circle.glade
	install -m 0644 src/database.glade ${DESTDIR}${UIDIR}/database.glade
	install -m 0644 src/date.glade ${DESTDIR}${UIDIR}/date.glade
	install -m 0644 src/export.glade ${DESTDIR}${UIDIR}/export.glade
	install -m 0644 src/export_page_setup.glade ${DESTDIR}${UIDIR}/export_page_setup.glade
	install -m 0644 src/fbarcode.glade ${DESTDIR}${UIDIR}/fbarcode.glade
	install -m 0644 src/field.glade ${DESTDIR}${UIDIR}/field.glade
	install -m 0644 src/fimage.glade ${DESTDIR}${UIDIR}/fimage.glade
	install -m 0644 src/fnumber.glade ${DESTDIR}${UIDIR}/fnumber.glade
	install -m 0644 src/frame.glade ${DESTDIR}${UIDIR}/frame.glade
	install -m 0644 src/fsum.glade ${DESTDIR}${UIDIR}/fsum.glade
	install -m 0644 src/ftext.glade ${DESTDIR}${UIDIR}/ftext.glade
	install -m 0644 src/image.glade ${DESTDIR}${UIDIR}/image.glade
	install -m 0644 src/label_page_setup.glade ${DESTDIR}${UIDIR}/label_page_setup.glade
	install -m 0644 src/layout_page_setup.glade ${DESTDIR}${UIDIR}/layout_page_setup.glade
	install -m 0644 src/line.glade ${DESTDIR}${UIDIR}/line.glade
	install -m 0644 src/mainwindow.glade ${DESTDIR}${UIDIR}/mainwindow.glade
	install -m 0644 src/page_number.glade ${DESTDIR}${UIDIR}/page_number.glade
	install -m 0644 src/query.glade ${DESTDIR}${UIDIR}/query.glade
	install -m 0644 src/README.glade ${DESTDIR}${UIDIR}/README
	install -m 0644 src/report.glade ${DESTDIR}${UIDIR}/report.glade
	install -m 0644 src/runreport.glade ${DESTDIR}${UIDIR}/runreport.glade
	install -m 0644 src/scrollwin.glade ${DESTDIR}${UIDIR}/scrollwin.glade
	install -m 0644 src/text.glade ${DESTDIR}${UIDIR}/text.glade

.PHONY: uninstall
uninstall:
	@echo uninstalling iwrite
	@rm -f ${DESTDIR}${BINDIR}/iwrite
	@rm -f ${DESTDIR}${LIBDIR}/libiwsql_pq.${SUFFIX} 
	@rm -f ${DESTDIR}${LIBDIR}/libiwsql_mariadb.${SUFFIX} 
	@rm -f ${DESTDIR}${LIBDIR}/libiwsql_sqlite3.${SUFFIX} 
	@rm -f ${DESTDIR}${LIBDIR}/libiwsql_oracle.${SUFFIX} 
	@rm -rf ${DESTDIR}${DOCDIR}
	@rm -rf ${DESTDIR}${DATADIR}

=== src/Makefile ===
# vim:noexpandtab:softtabstop=2:tabstop=2:shiftwidth=2:nowrap
# 
# Copyright (c) 2015-2016, iwrite authors
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 
# 1. Redistributions of source code must retain the above copyright notice,
# this list of conditions and the following disclaimer.
# 
# 2. Redistributions in binary form must reproduce the above copyright
# notice, this list of conditions and the following disclaimer in the
# documentation and/or other materials provided with the distribution.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
# TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

UNAME:= $(shell uname)

ifeq ($(UNAME), Linux)
LDFLAGS+= -ldl -lX11
PNG_LIB= -l png
else ifeq ($(UNAME), MINGW64_NT-10.0)
LDFLAGS+= -mwindows
PNG_LIB= -l png
else
LDFLAGS+= -Wl,-R/usr/X11R7/lib
PNG_LIB= -l png16
endif

ifeq ($(UNAME), FreeBSD)
LDFLAGS+= -lX11
endif

# use icu-config?
ICU4=`pkg-config --cflags icu-uc icu-io`
ICU4_LIB=`pkg-config --libs icu-uc icu-io`

GTK=`pkg-config gtk+-3.0 --cflags`
GTK_LIB=`pkg-config gtk+-3.0 --libs`

GMODULE=`pkg-config gmodule-export-2.0 --cflags`
GMODULE_LIB=`pkg-config gmodule-export-2.0 --libs`

ICU=-I icu/
ICU_LIB=-L icu/ -licu

DECN=-I decNumber/
DECN_LIB=-L decNumber/ -ldecnumber

IWSQL_DRIVER=-I../drivers/include

GEOM=-I geometry/
GEOM_LIB=-L geometry/ -lgeometry

ZINT=-I zint/
ZINT_LIB=zint/libzint.a ${PNG_LIB}

ZLIB=`pkg-config --cflags zlib`
ZLIB_LIB=`pkg-config --libs zlib`

CFLAGS=\
	${IWSQL_DRIVER}\
	${GTK}\
	${ICU}\
	${DECN}\
	${RULER}\
	${GEOM}\
	${GMODULE}\
	${ZINT}\
	${ZLIB}\
	-pthread\
	-Wall\
	-std=c99\
	-pedantic\
	-ggdb

CXXFLAGS:=${CFLAGS}

ALL_LIB=\
	${ZINT_LIB}\
	${GEOM_LIB}\
	${DECN_LIB}\
	${ICU_LIB}\
	${ICU4_LIB}\
	${ZLIB_LIB}\
	${GMODULE_LIB}\
	${GTK_LIB}\
	${LDFLAGS}\
	-lstdc++\
	-lm\

IWRITE_OBJECTS=\
	cmd.o\
	copybuf.o\
	database_aspect_database_property.o\
	database_aspect.o\
	database_aspect_property.o\
	database_config.o\
	database_field.o\
	database_field_property.o\
	database_session.o\
	driver_config.o\
	error.o\
	export_config.o\
	export_csv.o\
	export.o\
	export_page_setup_property.o\
	export_spec.o\
	global_common.o\
	handles.o\
	item_circle.o\
	item_circle_property.o\
	item_common_attr.o\
	item_common_base.o\
	item_common_box.o\
	item_common_circle.o\
	item_common_line.o\
	item_common_lookup.o\
	item_date.o\
	item_date_property.o\
	item_fbarcode.o\
	item_fbarcode_property.o\
	item_fimage.o\
	item_fimage_property.o\
	item_fnumber.o\
	item_fnumber_property.o\
	item_frame.o\
	item_frame_property.o\
	item_fsum.o\
	item_fsum_property.o\
	item_ftext.o\
	item_ftext_property.o\
	item_image.o\
	item_image_property.o\
	item_line.o\
	item_line_property.o\
	item.o\
	item_page_number.o\
	item_page_number_property.o\
	item_property.o\
	item_report.o\
	item_report_property.o\
	item_selection.o\
	item_text.o\
	item_text_property.o\
	iwr_page_menu.o\
	iwr_page.o\
	iwsql_dll.o\
	label.o\
	label_page_setup_property.o\
	label_paper.o\
	label_pdf.o\
	label_spec.o\
	layout_break_property.o\
	layout_loop.o\
	layout.o\
	layout_page_setup_property.o\
	layout_pdf.o\
	layout_spec.o\
	layout_subreport.o\
	layout_util.o\
	main.o\
	mainw.o\
	mainw_run.o\
	menu.o\
	option.o\
	paper.o\
	password.o\
	pixbuf.o\
	query_exec.o\
	query_exec2.o\
	query.o\
	query_property.o\
	report.o\
	report_util.o\
	run_dialog.o\
	rw.o\
	sql.o\
	symbology.o\
	version.o\
	wallet.o\
	xml.o

includes = ${wildcard *.h}

.PHONY: all
all: icu/libicu.a decNumber/libdecnumber.a\
	geometry/libgeometry.a zint/libzint.a iwrite

iwrite : ${IWRITE_OBJECTS}
	${CC} -o $@ ${IWRITE_OBJECTS} ${ALL_LIB}

%.o : %.c ${includes}
	${CC} -c ${CFLAGS} -o $@ $< 2> $@.err

item_common_lookup.o: item_common_lookup_gp.c

item_common_lookup_gp.c: item_common_lookup.gperf
	gperf -7 -D -t -L 'ANSI-C' item_common_lookup.gperf --output-file=item_common_lookup_gp.c

icu/libicu.a:
	@cd icu && ${MAKE}

decNumber/libdecnumber.a:
	@cd decNumber && ${MAKE}

geometry/libgeometry.a:
	@cd geometry && ${MAKE}

zint/libzint.a:
	@cd zint && ${MAKE}

clean:
	rm -f *.o
	rm -f *.o.err
	rm -f *.a
	rm -f *.so
	rm -f iwrite

=== drivers/mariadb/Makefile ===
# vim:noexpandtab:softtabstop=2:tabstop=2:shiftwidth=2:nowrap
# Copyright (c) 2015-2016, iwrite authors
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 
# 1. Redistributions of source code must retain the above copyright notice,
# this list of conditions and the following disclaimer.
# 
# 2. Redistributions in binary form must reproduce the above copyright
# notice, this list of conditions and the following disclaimer in the
# documentation and/or other materials provided with the distribution.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
# TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

RANLIB=ranlib

UNAME:= $(shell uname)

ifeq ($(UNAME), MINGW64_NT-10.0)

INC= -I /mingw64/include/mysql
CFLAGS+= -D DLL_INTERNAL
LIBS= -l mysqlclient
SUFFIX= dll

else

INC=`mysql_config --cflags`
LIBS=`mysql_config --libs`
SUFFIX= so
CFLAGS+= -fPIC

endif

CFLAGS+= -Wall -pedantic -ggdb ${INC} -I../include

OBJECTS=\
	iwsql_attr_delete.o\
	iwsql_connect.o\
	iwsql_delete.o\
	iwsql_error.o\
	iwsql_exec.o\
	iwsql_new.o\
	iwsql_next.o\
	iwsql_result.o\
	iwsql_show_databases.o\
	iwsql_show_tables.o

includes = ${wildcard *.h}

.PHONY: libs
libs: libiwsql_mariadb.${SUFFIX} libiwsql_mariadb.a

libiwsql_mariadb.${SUFFIX}: ${OBJECTS}
	${CC} -shared -o $@ $? ${LIBS}

libiwsql_mariadb.a: ${OBJECTS}
	${AR} rvc $@ $? 
	${RANLIB} $@

%.o : %.c ${includes}
	${CC} -c ${CFLAGS} -o $@ $< 2> $@.err

clean:
	rm -f *.o
	rm -f *.o.err
	rm -f *.a
	rm -f *.${SUFFIX}

=== drivers/oracle/Makefile ===
# vim:noexpandtab:softtabstop=2:tabstop=2:shiftwidth=2:nowrap
# Copyright (c) 2015, iwrite authors
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 
# 1. Redistributions of source code must retain the above copyright notice,
# this list of conditions and the following disclaimer.
# 
# 2. Redistributions in binary form must reproduce the above copyright
# notice, this list of conditions and the following disclaimer in the
# documentation and/or other materials provided with the distribution.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
# TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

RANLIB=ranlib

# TODO: use ORACLE_HOME ?

INC= -I ../include \
	-I /usr/include/oracle/12.1/client64/ \
	-I /opt/oracle/instantclient_12_1/sdk/include

LDFLAGS= \
	-L /usr/lib/oracle/12.1/client64/lib \
	-L /opt/oracle/instantclient_12_1 \
	-l mql1\
	-l ipc1\
	-l nnz12\
	-l ons\
	-l clntshcore\
	-l clntsh \
	-l occi 

CXXFLAGS+=-D_GLIBCXX_USE_CXX11_ABI=0
CXXFLAGS+=-fPIC -Wall -ansi -pedantic -Wno-variadic-macros -ggdb ${INC}

OBJECTS=\
	iwsql_attr_delete.o\
	iwsql_connect.o\
	iwsql_delete.o\
	iwsql_exec.o\
	iwsql_new.o\
	iwsql_next.o\
	iwsql_result.o\
	iwsql_show_databases.o\
	iwsql_show_tables.o\
	iwsql_type_translate.o

TEST_OBJECTS=\
	test.o

includes = ${wildcard *.h}

.PHONY: all
all: libs test

test: ${TEST_OBJECTS} libs
	${CXX} -o $@ ${TEST_OBJECTS} libiwsql_oracle.a ${LDFLAGS}

.PHONY: libs
libs: libiwsql_oracle.so libiwsql_oracle.a

libiwsql_oracle.so: ${OBJECTS}
	${CXX} -shared -o $@ $? ${LDFLAGS}

libiwsql_oracle.a: ${OBJECTS}
	${AR} rvc $@ $?
	${RANLIB} $@

%.o : %.c ${includes}
	${CXX} -c ${CXXFLAGS} -o $@ $< 2> $@.err

clean:
	rm -f *.o
	rm -f *.o.err
	rm -f *.a
	rm -f *.so
	rm -f test

=== drivers/postgres/Makefile ===
# vim:noexpandtab:softtabstop=2:tabstop=2:shiftwidth=2:nowrap
# Copyright (c) 2015-2016, iwrite authors
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 
# 1. Redistributions of source code must retain the above copyright notice,
# this list of conditions and the following disclaimer.
# 
# 2. Redistributions in binary form must reproduce the above copyright
# notice, this list of conditions and the following disclaimer in the
# documentation and/or other materials provided with the distribution.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
# TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

RANLIB=ranlib

UNAME:= $(shell uname)

INC= -I../include
SUFFIX= so

ifeq ($(UNAME), MINGW64_NT-10.0)

INC+= -I /mingw64/include/postgresql/server
INC+= -I /mingw64/include/postgresql/server/port/win32
SUFFIX= dll
CXXFLAGS+= -D DLL_INTERNAL
LDFLAGS= -lpq

else

CXXFLAGS+= -fPIC -pedantic 

endif

ifeq ($(UNAME), Linux)

INC+= -I/usr/include/postgresql/server
INC+= -I/usr/include/pgsql/server

# postgressql 9.4 (Debian)
INC+= -I/usr/include/postgresql
INC+= -I/usr/include/postgresql/9.4/server

LDFLAGS= -lpq

endif

ifeq ($(UNAME), NetBSD)

INC+= -I/usr/pkg/include/
INC+= -I/usr/pkg/include/postgresql/server
LDFLAGS= -L /usr/pkg/lib -lpq

endif

ifeq ($(UNAME), OpenBSD)

INC+= -I /usr/local/include/postgresql/
INC+= -I /usr/local/include/postgresql/server/
LDFLAGS= -L /usr/local/lib -lpq

endif

ifeq ($(UNAME), FreeBSD)

INC+= -I /usr/local/include
INC+= -I /usr/local/include/postgresql/
INC+= -I /usr/local/include/postgresql/server/
LDFLAGS= -L /usr/local/lib -lpq

endif

CXXFLAGS+= -Wall -ansi -Wno-variadic-macros -ggdb ${INC}

OBJECTS=\
	iwsql_attr_delete.o\
	iwsql_connect.o\
	iwsql_delete.o\
	iwsql_error.o\
	iwsql_exec.o\
	iwsql_new.o\
	iwsql_next.o\
	iwsql_result.o\
	iwsql_show_databases.o\
	iwsql_show_tables.o\
	iwsql_oid_translate.o

includes = ${wildcard *.h}

.PHONY: libs
libs: libiwsql_pq.${SUFFIX} libiwsql_pq.a

libiwsql_pq.${SUFFIX}: ${OBJECTS}
	${CXX} -shared -o $@ $? ${LDFLAGS}

libiwsql_pq.a: ${OBJECTS}
	${AR} rvc $@ $?
	${RANLIB} $@

%.o : %.cxx ${includes}
	${CXX} -c ${CXXFLAGS} -o $@ $< 2> $@.err

clean:
	rm -f *.o
	rm -f *.o.err
	rm -f *.a
	rm -f *.${SUFFIX}

=== drivers/sqlite3/Makefile ===
# vim:noexpandtab:softtabstop=2:tabstop=2:shiftwidth=2:nowrap
# Copyright (c) 2015-2016, iwrite authors
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 
# 1. Redistributions of source code must retain the above copyright notice,
# this list of conditions and the following disclaimer.
# 
# 2. Redistributions in binary form must reproduce the above copyright
# notice, this list of conditions and the following disclaimer in the
# documentation and/or other materials provided with the distribution.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
# TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

RANLIB=ranlib

UNAME:= $(shell uname)

ifeq ($(UNAME), MINGW64_NT-10.0)

CFLAGS+= -D DLL_INTERNAL
SUFFIX= dll

else

SUFFIX= so
CFLAGS+= -fPIC

endif

INC=-I../include

CFLAGS+= -Wall -pedantic -ggdb ${INC}

LDFLAGS+= -lsqlite3

OBJECTS=\
	iwsql_attr_delete.o\
	iwsql_connect.o\
	iwsql_delete.o\
	iwsql_error_code.o\
	iwsql_exec.o\
	iwsql_new.o\
	iwsql_next.o\
	iwsql_result.o\
	iwsql_show_databases.o\
	iwsql_show_tables.o

includes = ${wildcard *.h}

.PHONY: libs
libs: libiwsql_sqlite3.${SUFFIX} libiwsql_sqlite3.a

libiwsql_sqlite3.${SUFFIX}: ${OBJECTS}
	${CC} -shared -o $@ $? ${LDFLAGS}

libiwsql_sqlite3.a: ${OBJECTS}
	${AR} rvc $@ $? 
	${RANLIB} $@

%.o : %.c ${includes}
	${CC} -c ${CFLAGS} -o $@ $< 2> $@.err

clean:
	rm -f *.o
	rm -f *.o.err
	rm -f *.a
	rm -f *.${SUFFIX}

=== packaging/MinGW64/Makefile ===
# vim:noexpandtab:softtabstop=2:tabstop=2:shiftwidth=2:nowrap
# 
# Copyright (c) 2016, iwrite authors
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 
# 1. Redistributions of source code must retain the above copyright notice,
# this list of conditions and the following disclaimer.
# 
# 2. Redistributions in binary form must reproduce the above copyright
# notice, this list of conditions and the following disclaimer in the
# documentation and/or other materials provided with the distribution.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
# TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

DLL=/mingw64/bin
TOP=../..
SRC=${TOP}/src
DBD=${TOP}/drivers
BIN=bin
SHARE=share

DRIVER=\
	${BIN}/libiwsql_mariadb.dll\
	${BIN}/libiwsql_pq.dll\
	${BIN}/libiwsql_sqlite3.dll

GLADE=\
	${BIN}/break.glade\
	${BIN}/circle.glade\
	${BIN}/database.glade\
	${BIN}/date.glade\
	${BIN}/export.glade\
	${BIN}/export_page_setup.glade\
	${BIN}/fbarcode.glade\
	${BIN}/field.glade\
	${BIN}/fimage.glade\
	${BIN}/fnumber.glade\
	${BIN}/frame.glade\
	${BIN}/fsum.glade\
	${BIN}/ftext.glade\
	${BIN}/image.glade\
	${BIN}/label_page_setup.glade\
	${BIN}/layout_page_setup.glade\
	${BIN}/line.glade\
	${BIN}/mainwindow.glade\
	${BIN}/page_number.glade\
	${BIN}/query.glade\
	${BIN}/README.glade\
	${BIN}/report.glade\
	${BIN}/runreport.glade\
	${BIN}/scrollwin.glade\
	${BIN}/text.glade

DEPDLL=\
	${BIN}/libatk-1.0-0.dll\
	${BIN}/libbz2-1.dll\
	${BIN}/libcairo-2.dll\
	${BIN}/libcairo-gobject-2.dll\
	${BIN}/libepoxy-0.dll\
	${BIN}/libexpat-1.dll\
	${BIN}/libffi-6.dll\
	${BIN}/libfontconfig-1.dll\
	${BIN}/libfreetype-6.dll\
	${BIN}/libgcc_s_seh-1.dll\
	${BIN}/libgdk_pixbuf-2.0-0.dll\
	${BIN}/libgdk-3-0.dll\
	${BIN}/libgio-2.0-0.dll\
	${BIN}/libglib-2.0-0.dll\
	${BIN}/libgmodule-2.0-0.dll\
	${BIN}/libgobject-2.0-0.dll\
	${BIN}/libgraphite2.dll\
	${BIN}/libgtk-3-0.dll\
	${BIN}/libharfbuzz-0.dll\
	${BIN}/libiconv-2.dll\
	${BIN}/libicudt57.dll\
	${BIN}/libicuin57.dll\
	${BIN}/libicuuc57.dll\
	${BIN}/libintl-8.dll\
	${BIN}/libpango-1.0-0.dll\
	${BIN}/libpangocairo-1.0-0.dll\
	${BIN}/libpangoft2-1.0-0.dll\
	${BIN}/libpangowin32-1.0-0.dll\
	${BIN}/libpcre-1.dll\
	${BIN}/libpixman-1-0.dll\
	${BIN}/libpng16-16.dll\
	${BIN}/libpq.dll\
	${BIN}/libsqlite3-0.dll\
	${BIN}/libstdc++-6.dll\
	${BIN}/libwinpthread-1.dll\
	${BIN}/mariadb.dll\
	${BIN}/zlib1.dll

.PHONY: all
all: createdirs bin share

createdirs:
	@test -d ${BIN} || mkdir -p ${BIN}
	@test -d ${SHARE} || mkdir -p ${SHARE}

.PHONY: share
share: icons glib gtk

.PHONY: icons
icons:
	@test -d ${SHARE}/icons || mkdir -p ${SHARE}/icons
	@rsync -r /mingw64/share/icons ${SHARE}

.PHONY: glib
glib:
	@test -d ${SHARE}/glib-2.0/schemas || mkdir -p ${SHARE}/glib-2.0/schemas
	@rsync /mingw64/share/glib-2.0/schemas/gschema.dtd ${SHARE}/glib-2.0/schemas
	@rsync /mingw64/share/glib-2.0/schemas/org.gtk.Settings.ColorChooser.gschema.xml ${SHARE}/glib-2.0/schemas/
	@rsync /mingw64/share/glib-2.0/schemas/org.gtk.Settings.FileChooser.gschema.xml ${SHARE}/glib-2.0/schemas/
	@cd ${SHARE}/glib-2.0/schemas && glib-compile-schemas .

.PHONY: gtk
gtk:
	@test -d ${SHARE}/gtk-3.0 || mkdir -p ${SHARE}/gtk-3.0
	@rsync /mingw64/share/gtk-3.0/gtkbuilder.rng ${SHARE}/gtk-3.0/

.PHONY: bin
bin: ${DEPDLL} ${GLADE} ${DRIVER} ${BIN}/iwrite.exe ${BIN}/COPYING ${BIN}/README
	

${BIN}/iwrite.exe: ${SRC}/iwrite.exe
	install -s -m 0655 $? $@

${SRC}/iwrite.exe:
	cd ${TOP} && make

${BIN}/COPYING: ${TOP}/COPYING
	install -m 0644 $? $@

${BIN}/README: ${TOP}/README
	install -m 0644 $? $@

# ----------------
# DATABASE DRIVER
# ----------------

${BIN}/libiwsql_mariadb.dll: ${DBD}/mariadb/libiwsql_mariadb.dll
	install -s -m 0655 $? $@

${DBD}/mariadb/libiwsql_mariadb.dll:
	cd ${TOP} && make

${BIN}/libiwsql_pq.dll: ${DBD}/postgres/libiwsql_pq.dll
	install -s -m 0655 $? $@

${DBD}/postgres/libiwsql_pq.dll:
	cd ${TOP} && make

${BIN}/libiwsql_sqlite3.dll: ${DBD}/sqlite3/libiwsql_sqlite3.dll
	install -s -m 0655 $? $@

${DBD}/sqlite3/libiwsql_sqlite3.dll:
	cd ${TOP} && make

# ----------------
# GLADE DEPENDENCIES
# ----------------

${BIN}/break.glade: ${SRC}/break.glade
	install -m 0644 $? $@

${BIN}/circle.glade: ${SRC}/circle.glade
	install -m 0644 $? $@

${BIN}/database.glade: ${SRC}/database.glade
	install -m 0644 $? $@

${BIN}/date.glade: ${SRC}/date.glade
	install -m 0644 $? $@

${BIN}/export.glade: ${SRC}/export.glade
	install -m 0644 $? $@

${BIN}/export_page_setup.glade: ${SRC}/export_page_setup.glade
	install -m 0644 $? $@

${BIN}/fbarcode.glade: ${SRC}/fbarcode.glade
	install -m 0644 $? $@

${BIN}/field.glade: ${SRC}/field.glade
	install -m 0644 $? $@

${BIN}/fimage.glade: ${SRC}/fimage.glade
	install -m 0644 $? $@

${BIN}/fnumber.glade: ${SRC}/fnumber.glade
	install -m 0644 $? $@

${BIN}/frame.glade: ${SRC}/frame.glade
	install -m 0644 $? $@

${BIN}/fsum.glade: ${SRC}/fsum.glade
	install -m 0644 $? $@

${BIN}/ftext.glade: ${SRC}/ftext.glade
	install -m 0644 $? $@

${BIN}/image.glade: ${SRC}/image.glade
	install -m 0644 $? $@

${BIN}/label_page_setup.glade: ${SRC}/label_page_setup.glade
	install -m 0644 $? $@

${BIN}/layout_page_setup.glade: ${SRC}/layout_page_setup.glade
	install -m 0644 $? $@

${BIN}/line.glade: ${SRC}/line.glade
	install -m 0644 $? $@

${BIN}/mainwindow.glade: ${SRC}/mainwindow.glade
	install -m 0644 $? $@

${BIN}/page_number.glade: ${SRC}/page_number.glade
	install -m 0644 $? $@

${BIN}/query.glade: ${SRC}/query.glade
	install -m 0644 $? $@

${BIN}/README.glade: ${SRC}/README.glade
	install -m 0644 $? $@

${BIN}/report.glade: ${SRC}/report.glade
	install -m 0644 $? $@

${BIN}/runreport.glade: ${SRC}/runreport.glade
	install -m 0644 $? $@

${BIN}/scrollwin.glade: ${SRC}/scrollwin.glade
	install -m 0644 $? $@

${BIN}/text.glade: ${SRC}/text.glade
	install -m 0644 $? $@

# ----------------
# DLL DEPENDENCIES
# ----------------

${BIN}/libatk-1.0-0.dll: ${DLL}/libatk-1.0-0.dll
	install -s -m 0655 $? $@

${BIN}/libbz2-1.dll: ${DLL}/libbz2-1.dll
	install -s -m 0655 $? $@

${BIN}/libcairo-2.dll: ${DLL}/libcairo-2.dll
	install -s -m 0655 $? $@

${BIN}/libcairo-gobject-2.dll: ${DLL}/libcairo-gobject-2.dll
	install -s -m 0655 $? $@

${BIN}/libepoxy-0.dll: ${DLL}/libepoxy-0.dll
	install -s -m 0655 $? $@

${BIN}/libexpat-1.dll: ${DLL}/libexpat-1.dll
	install -s -m 0655 $? $@

${BIN}/libffi-6.dll: ${DLL}/libffi-6.dll
	install -s -m 0655 $? $@

${BIN}/libfontconfig-1.dll: ${DLL}/libfontconfig-1.dll
	install -s -m 0655 $? $@

${BIN}/libfreetype-6.dll: ${DLL}/libfreetype-6.dll
	install -s -m 0655 $? $@

${BIN}/libgcc_s_seh-1.dll: ${DLL}/libgcc_s_seh-1.dll
	install -s -m 0655 $? $@

${BIN}/libgdk_pixbuf-2.0-0.dll: ${DLL}/libgdk_pixbuf-2.0-0.dll
	install -s -m 0655 $? $@

${BIN}/libgdk-3-0.dll: ${DLL}/libgdk-3-0.dll
	install -s -m 0655 $? $@

${BIN}/libgio-2.0-0.dll: ${DLL}/libgio-2.0-0.dll
	install -s -m 0655 $? $@

${BIN}/libglib-2.0-0.dll: ${DLL}/libglib-2.0-0.dll
	install -s -m 0655 $? $@

${BIN}/libgmodule-2.0-0.dll: ${DLL}/libgmodule-2.0-0.dll
	install -s -m 0655 $? $@

${BIN}/libgobject-2.0-0.dll: ${DLL}/libgobject-2.0-0.dll
	install -s -m 0655 $? $@

${BIN}/libgraphite2.dll: ${DLL}/libgraphite2.dll
	install -s -m 0655 $? $@

${BIN}/libgtk-3-0.dll: ${DLL}/libgtk-3-0.dll
	install -s -m 0655 $? $@

${BIN}/libharfbuzz-0.dll: ${DLL}/libharfbuzz-0.dll
	install -s -m 0655 $? $@

${BIN}/libiconv-2.dll: ${DLL}/libiconv-2.dll
	install -s -m 0655 $? $@

${BIN}/libicudt57.dll: ${DLL}/libicudt57.dll
	install -s -m 0655 $? $@

${BIN}/libicuin57.dll: ${DLL}/libicuin57.dll
	install -s -m 0655 $? $@

${BIN}/libicuuc57.dll: ${DLL}/libicuuc57.dll
	install -s -m 0655 $? $@

${BIN}/libintl-8.dll: ${DLL}/libintl-8.dll
	install -s -m 0655 $? $@

${BIN}/libpango-1.0-0.dll: ${DLL}/libpango-1.0-0.dll
	install -s -m 0655 $? $@

${BIN}/libpangocairo-1.0-0.dll: ${DLL}/libpangocairo-1.0-0.dll
	install -s -m 0655 $? $@

${BIN}/libpangoft2-1.0-0.dll: ${DLL}/libpangoft2-1.0-0.dll
	install -s -m 0655 $? $@

${BIN}/libpangowin32-1.0-0.dll: ${DLL}/libpangowin32-1.0-0.dll
	install -s -m 0655 $? $@

${BIN}/libpcre-1.dll: ${DLL}/libpcre-1.dll
	install -s -m 0655 $? $@

${BIN}/libpixman-1-0.dll: ${DLL}/libpixman-1-0.dll
	install -s -m 0655 $? $@

${BIN}/libpng16-16.dll: ${DLL}/libpng16-16.dll
	install -s -m 0655 $? $@

${BIN}/libpq.dll: ${DLL}/libpq.dll
	install -s -m 0655 $? $@

${BIN}/libsqlite3-0.dll: ${DLL}/libsqlite3-0.dll
	install -s -m 0655 $? $@

${BIN}/libstdc++-6.dll: ${DLL}/libstdc++-6.dll
	install -s -m 0655 $? $@

${BIN}/libwinpthread-1.dll: ${DLL}/libwinpthread-1.dll
	install -s -m 0655 $? $@

${BIN}/mariadb.dll: ${DLL}/mariadb.dll
	install -s -m 0655 $? $@

${BIN}/zlib1.dll: ${DLL}/zlib1.dll
	install -s -m 0655 $? $@

=== packaging/debian/changelog ===
iwrite (3.1.1.0-1) unstable; urgency=low

  * Add Sub-report

 -- Mark Olesen <markjolesen@gmail.com>  Wed, 20 Jul 2016 21:29:38 -0700

iwrite (3.0.1.0-1) unstable; urgency=low

  * Add edit/undo
  * Bug fixes

 -- Mark Olesen <markjolesen@gmail.com>  Sun, 05 Jun 2016 06:47:46 -0700

iwrite (2.0.1.0-1) unstable; urgency=low

  * Use XML instead of BSON

 -- Mark Olesen <markjolesen@gmail.com>  Fri, 12 Feb 2016 01:10:17 -0700

iwrite (1.0.1.4-1) unstable; urgency=low

  * Initial beta release.

 -- Mark Olesen <markjolesen@gmail.com>  Tue, 12 Jan 2016 01:22:49 -0700

=== packaging/abs/PKGBUILD ===
pkgname=iwrite
pkgver=3.1.1.0
pkgrel=1
pkgdesc='SQL report writer'
arch=('i686' 'x86_64')
url='http://www.nongnu.org/iwrite/'
license=('BSD')
depends=('icu' 'gtk3')
# makedepends need to add postgres mariadb or mysql client + oracle client libs
source=(
"http://download.savannah.gnu.org/releases/iwrite/$pkgname-$pkgver.tar.gz"
"http://download.savannah.gnu.org/releases/iwrite/$pkgname-$pkgver.tar.gz.sig"
)

md5sums=('SKIP' 'SKIP')


build() {
  cd "$srcdir/$pkgname-$pkgver"
  make
}

package() {
  cd "$srcdir/$pkgname-$pkgver"
  make DESTDIR="$pkgdir" LIBDIR=/usr/lib install
}
